diff -Naur ruby-1.9.3-p547.original/vm.inc ruby-1.9.3-p547.htm/vm.inc
--- ruby-1.9.3-p547.original/vm.inc	2014-05-16 23:38:33.000000000 +0900
+++ ruby-1.9.3-p547.htm/vm.inc	2014-09-12 06:37:35.905002000 +0900
@@ -2890,7 +2938,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_not));
   USAGE_ANALYSIS_OPERAND(BIN(opt_not), 0, ic);
 {
-#line 2064 "insns.def"
+#line 2089 "insns.def"
     extern VALUE rb_obj_not(VALUE obj);
     const rb_method_entry_t *me = vm_method_search(idNot, CLASS_OF(recv), ic);
 
@@ -2902,7 +2950,7 @@
 	CALL_SIMPLE_METHOD(0, idNot, recv);
     }
 
-#line 2906 "vm.inc"
+#line 2954 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_not
@@ -2926,10 +2974,10 @@
   USAGE_ANALYSIS_INSN(BIN(opt_regexpmatch1));
   USAGE_ANALYSIS_OPERAND(BIN(opt_regexpmatch1), 0, r);
 {
-#line 2088 "insns.def"
+#line 2113 "insns.def"
     val = rb_reg_match(r, obj);
 
-#line 2933 "vm.inc"
+#line 2981 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_regexpmatch1
@@ -2953,7 +3001,7 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(opt_regexpmatch2));
 {
-#line 2102 "insns.def"
+#line 2127 "insns.def"
     if (TYPE(obj2) == T_STRING) {
 	val = rb_reg_match(obj1, obj2);
     }
@@ -2961,7 +3009,7 @@
 	val = rb_funcall(obj2, idEqTilde, 1, obj1);
     }
 
-#line 2965 "vm.inc"
+#line 3013 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(val);
 #undef CURRENT_INSN_opt_regexpmatch2
@@ -2983,7 +3031,7 @@
   USAGE_ANALYSIS_INSN(BIN(opt_call_c_function));
   USAGE_ANALYSIS_OPERAND(BIN(opt_call_c_function), 0, funcptr);
 {
-#line 2121 "insns.def"
+#line 2146 "insns.def"
     reg_cfp = (funcptr)(th, reg_cfp);
 
     if (reg_cfp == 0) {
@@ -2995,7 +3043,7 @@
     RESTORE_REGS();
     NEXT_INSN();
 
-#line 2999 "vm.inc"
+#line 3047 "vm.inc"
 #undef CURRENT_INSN_opt_call_c_function
 #undef INSN_IS_SC
 #undef INSN_LABEL
@@ -3015,10 +3063,10 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(bitblt));
 {
-#line 2144 "insns.def"
+#line 2169 "insns.def"
     ret = rb_str_new2("a bit of bacon, lettuce and tomato");
 
-#line 3022 "vm.inc"
+#line 3070 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(ret);
 #undef CURRENT_INSN_bitblt
@@ -3040,10 +3088,10 @@
   #define LABEL_IS_SC(lab) LABEL_##lab##_##t
   USAGE_ANALYSIS_INSN(BIN(answer));
 {
-#line 2158 "insns.def"
+#line 2183 "insns.def"
     ret = INT2FIX(42);
 
-#line 3047 "vm.inc"
+#line 3095 "vm.inc"
   CHECK_STACK_OVERFLOW(REG_CFP, 1);
   PUSH(ret);
 #undef CURRENT_INSN_answer
diff -Naur ruby-1.9.3-p547.original/vm_insnhelper.c ruby-1.9.3-p547.htm/vm_insnhelper.c
--- ruby-1.9.3-p547.original/vm_insnhelper.c	2013-02-22 14:42:27.000000000 +0900
+++ ruby-1.9.3-p547.htm/vm_insnhelper.c	2014-09-12 06:37:35.905002000 +0900
@@ -5,6 +5,7 @@
   $Author: usa $
 
   Copyright (C) 2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -1264,8 +1265,12 @@
 }
 
 #ifndef USE_IC_FOR_IVAR
+#if defined(HTM_GVL) && ! defined(USE_TABLE_FOR_IC_IVAR)
+#define USE_IC_FOR_IVAR 0
+#else
 #define USE_IC_FOR_IVAR 1
 #endif
+#endif
 
 static VALUE
 vm_getivar(VALUE obj, ID id, IC ic)
@@ -1273,10 +1278,21 @@
 #if USE_IC_FOR_IVAR
     if (TYPE(obj) ==  T_OBJECT) {
 	VALUE val = Qundef;
+#ifdef USE_TABLE_FOR_IC_IVAR
+	struct st_table *iv_index_tbl = ROBJECT_IV_INDEX_TBL(obj);
+#else
 	VALUE klass = RBASIC(obj)->klass;
+#endif
 
-	if (LIKELY(ic->ic_class == klass &&
-		   ic->ic_vmstat == GET_VM_STATE_VERSION())) {
+	if (
+#ifdef USE_TABLE_FOR_IC_IVAR
+	    LIKELY(iv_index_tbl != NULL && ic->ic_guard.ic_tbl == iv_index_tbl &&
+		   ic->ic_vmstat == GET_VM_STATE_VERSION())
+#else
+	    LIKELY(ic->ic_class == klass &&
+		   ic->ic_vmstat == GET_VM_STATE_VERSION())
+#endif
+	    ) {
 	    long index = ic->ic_value.index;
 	    long len = ROBJECT_NUMIV(obj);
 	    VALUE *ptr = ROBJECT_IVPTR(obj);
@@ -1289,14 +1305,20 @@
 	    st_data_t index;
 	    long len = ROBJECT_NUMIV(obj);
 	    VALUE *ptr = ROBJECT_IVPTR(obj);
+#ifndef USE_TABLE_FOR_IC_IVAR
 	    struct st_table *iv_index_tbl = ROBJECT_IV_INDEX_TBL(obj);
+#endif
 
 	    if (iv_index_tbl) {
 		if (st_lookup(iv_index_tbl, id, &index)) {
 		    if ((long)index < len) {
 			val = ptr[index];
 		    }
+#ifdef USE_TABLE_FOR_IC_IVAR
+		    ic->ic_guard.ic_tbl = iv_index_tbl;
+#else
 		    ic->ic_class = klass;
+#endif
 		    ic->ic_value.index = index;
 		    ic->ic_vmstat = GET_VM_STATE_VERSION();
 		}
@@ -1327,11 +1349,22 @@
     rb_check_frozen(obj);
 
     if (TYPE(obj) == T_OBJECT) {
+#ifdef USE_TABLE_FOR_IC_IVAR
+	struct st_table *iv_index_tbl = ROBJECT_IV_INDEX_TBL(obj);
+#else
 	VALUE klass = RBASIC(obj)->klass;
+#endif
 	st_data_t index;
 
-	if (LIKELY(ic->ic_class == klass &&
-		   ic->ic_vmstat == GET_VM_STATE_VERSION())) {
+	if (
+#ifdef USE_TABLE_FOR_IC_IVAR
+	    LIKELY(iv_index_tbl != NULL && ic->ic_guard.ic_tbl == iv_index_tbl &&
+		   ic->ic_vmstat == GET_VM_STATE_VERSION())
+#else
+	    LIKELY(ic->ic_class == klass &&
+		   ic->ic_vmstat == GET_VM_STATE_VERSION())
+#endif
+	    ) {
 	    long index = ic->ic_value.index;
 	    long len = ROBJECT_NUMIV(obj);
 	    VALUE *ptr = ROBJECT_IVPTR(obj);
@@ -1342,10 +1375,16 @@
 	    }
 	}
 	else {
+#ifndef USE_TABLE_FOR_IC_IVAR
 	    struct st_table *iv_index_tbl = ROBJECT_IV_INDEX_TBL(obj);
+#endif
 
 	    if (iv_index_tbl && st_lookup(iv_index_tbl, (st_data_t)id, &index)) {
+#ifdef USE_TABLE_FOR_IC_IVAR
+		ic->ic_guard.ic_tbl = iv_index_tbl;
+#else
 		ic->ic_class = klass;
+#endif
 		ic->ic_value.index = index;
 		ic->ic_vmstat = GET_VM_STATE_VERSION();
 	    }
@@ -1363,15 +1402,39 @@
 {
     rb_method_entry_t *me;
 #if OPT_INLINE_METHOD_CACHE
-    if (LIKELY(klass == ic->ic_class &&
-	GET_VM_STATE_VERSION() == ic->ic_vmstat)) {
+    if (
+#ifdef USE_TABLE_FOR_IC_IVAR
+	LIKELY(klass == ic->ic_guard.ic_class &&
+	GET_VM_STATE_VERSION() == ic->ic_vmstat)
+#else
+	LIKELY(klass == ic->ic_class &&
+	GET_VM_STATE_VERSION() == ic->ic_vmstat)
+#endif
+	) {
 	me = ic->ic_value.method;
     }
     else {
 	me = rb_method_entry(klass, id);
+#ifdef ADAPTIVE_INLINE_METHOD_CACHE
+	/* Fill a cache only at the first time */
+	if (
+#ifdef USE_TABLE_FOR_IC_IVAR
+	    ic->ic_guard.ic_class == 0
+#else
+	    ic->ic_class == 0
+#endif
+	    ) {
+#endif /* ADAPTIVE_INLINE_METHOD_CACHE */
+#ifdef USE_TABLE_FOR_IC_IVAR
+	ic->ic_guard.ic_class = klass;
+#else
 	ic->ic_class = klass;
+#endif
 	ic->ic_value.method = me;
 	ic->ic_vmstat = GET_VM_STATE_VERSION();
+#ifdef ADAPTIVE_INLINE_METHOD_CACHE
+	}
+#endif /* ADAPTIVE_INLINE_METHOD_CACHE */
     }
 #else
     me = rb_method_entry(klass, id);
diff -Naur ruby-1.9.3-p547.original/vm_method.c ruby-1.9.3-p547.htm/vm_method.c
--- ruby-1.9.3-p547.original/vm_method.c	2013-02-22 14:42:27.000000000 +0900
+++ ruby-1.9.3-p547.htm/vm_method.c	2014-09-12 06:37:35.905002000 +0900
@@ -1,5 +1,6 @@
 /*
  * This file is included by vm.c
+  Copyright (c) IBM Corp. 2014.
  */
 
 #define CACHE_SIZE 0x800
@@ -395,6 +396,14 @@
     if (ruby_running) {
 	struct cache_entry *ent;
 	ent = cache + EXPR1(klass, id);
+#ifdef ADAPTIVE_GLOBAL_METHOD_CACHE
+	if (ent->mid != 0) {
+	    if (UNDEFINED_METHOD_ENTRY_P(me)) {
+		me = 0;
+	    }
+	    return me;
+	}
+#endif
 	ent->filled_version = GET_VM_STATE_VERSION();
 	ent->klass = klass;
 
diff -Naur ruby-1.9.3-p547.original/vm_opts.h ruby-1.9.3-p547.htm/vm_opts.h
--- ruby-1.9.3-p547.original/vm_opts.h	2009-10-02 21:04:37.000000000 +0900
+++ ruby-1.9.3-p547.htm/vm_opts.h	2014-09-12 06:37:35.905002000 +0900
@@ -6,6 +6,7 @@
   $Author: akr $
 
   Copyright (C) 2004-2007 Koichi Sasada
+  Copyright (c) IBM Corp. 2014.
 
 **********************************************************************/
 
@@ -36,7 +37,11 @@
 
 /* VM running option */
 #define OPT_CHECKED_RUN              1
+#if defined(HTM_GVL) && ! defined(ADAPTIVE_INLINE_METHOD_CACHE)
+#define OPT_INLINE_METHOD_CACHE      0
+#else
 #define OPT_INLINE_METHOD_CACHE      1
+#endif
 #define OPT_BLOCKINLINING            0
 
 /* architecture independent, affects generated code */
